import math;
import hyperbolic_geometry;

size(500,500);
settings.outformat="pdf";

// What do we want to test?
// Some more or less random hyperbolic segments which
// are used as radii for hyperbolic circles

hyperbolic_point[] P;

P[0] = hyperbolic_point(1,30);
P[1] = hyperbolic_point(1,60);
P[2] = hyperbolic_point(2.4,210);
P[3] = hyperbolic_point(1.2,135);
P[4] = hyperbolic_point(0,5);
P[5] = hyperbolic_point(2,5);
P[6] = hyperbolic_point(2.8,80);
P[7] = hyperbolic_point(2.8,100);
P[8] = hyperbolic_point(1.2,80);
P[9] = hyperbolic_point(1.2,100);
P[10] = hyperbolic_point(1.6,200);
P[11] = hyperbolic_point(2,310);
P[12] = hyperbolic_point(1,110);
P[13] = hyperbolic_point(1.3,0);
P[14] = hyperbolic_point(1.8,45);
P[15] = hyperbolic_point(1.9,225);

hyperbolic_segment S;
hyperbolic_circle[] C;


for (int i = 0; i < 14; ++i) {
    S = hyperbolic_segment(P[i], P[i+1]);
    draw(S, blue);
    dot(P[i]);
    C[i] = hyperbolic_circle(P[i], P[i+1]);
    draw(C[i]);
}

hyperbolic_point[] I;
for (int i = 0; i < C.length-1; ++i) {
    I = intersection(C[i], C[i+1]);
    dot(I, orange);
}



draw((1,1)--(1,-1)--(-1,-1)--(-1,1)--cycle);
draw(unitcircle);
