import math;
import hyperbolic_geometry;

size(500,500);
settings.outformat="pdf";

// What do we want to test?
// Concentric circles around the origin and
// circles which go through the origin.

hyperbolic_point O = hyperbolic_point(0,0);

hyperbolic_point X;
hyperbolic_circle circ;
for(real rad = 0.1; rad < 4.5; rad += 0.2) {
    X = hyperbolic_point(rad, 135);
    circ = hyperbolic_circle(O,X);

    draw(circ, blue);
    dot(X, blue);
}

for(real rad = 0.125; rad < 4.5; rad += 0.2) {
    X = hyperbolic_point(rad, 350);
    circ = hyperbolic_circle(X,O);

    draw(circ, yellow);
    dot(X, yellow);
}

dot(O,black);

draw((1,1)--(1,-1)--(-1,-1)--(-1,1)--cycle);
draw(unitcircle);
