import math;
import hyperbolic_geometry;

size(500,500);
settings.outformat="pdf";

// What do we want to test?
// Hyperbolic circles through three given points.

hyperbolic_point P1 = hyperbolic_point(1, 20);
hyperbolic_point P2 = hyperbolic_point(1.2, 50);
hyperbolic_point P3 = hyperbolic_point(2, 35);
hyperbolic_circle C = hyperbolic_circle(P1, P2, P3);
draw(C, blue);
dot(P1);
dot(P2);
dot(P3);


hyperbolic_point P1 = hyperbolic_point(1, 0);
hyperbolic_point P2 = hyperbolic_point(1, 90);
hyperbolic_point P3 = hyperbolic_point(0, 0);
hyperbolic_circle C = hyperbolic_circle(P1, P2, P3);
draw(C, red);
dot(P1);
dot(P2);
dot(P3);


hyperbolic_point P1 = hyperbolic_point(2, 0);
hyperbolic_point P2 = hyperbolic_point(2, 80);
hyperbolic_point P3 = hyperbolic_point(1, 10);
hyperbolic_circle C = hyperbolic_circle(P1, P2, P3);
draw(C, yellow);
dot(P1);
dot(P2);
dot(P3);


hyperbolic_point P1 = hyperbolic_point(2, 0);
hyperbolic_point P2 = hyperbolic_point(2, 120);
hyperbolic_point P3 = hyperbolic_point(2, 240);
hyperbolic_circle C = hyperbolic_circle(P1, P2, P3);
draw(C, green);
dot(P1);
dot(P2);
dot(P3);


hyperbolic_point P1 = hyperbolic_point(2, 190);
hyperbolic_point P2 = hyperbolic_point(1, 130);
hyperbolic_point P3 = hyperbolic_point(0.5, 200);
hyperbolic_circle C = hyperbolic_circle(P1, P2, P3);
draw(C, orange);
dot(P1);
dot(P2);
dot(P3);

draw((1,1)--(1,-1)--(-1,-1)--(-1,1));
draw(unitcircle);
