import math;
import hyperbolic_geometry;

size(500,500);
settings.outformat="pdf";

// What do we want to test?
// The calculation of mirrors from given points.

hyperbolic_point O = hyperbolic_point(0,0);
dot(O,red);

hyperbolic_point P;
hyperbolic_line M;
hyperbolic_point Q;

hyperbolic_point R = hyperbolic_point();
hyperbolic_line X = hyperbolic_line();

real radius = 0.2;
for(real angle = 0; angle <=360 ; angle +=10) {
    P = hyperbolic_point(radius,angle);
    dot(P, black);

    M = find_mirror_to_origin(P);
    draw(M, gray);

    // Just a test
    //Q = mirror(M, P);
    //dot(Q, blue);

    X = find_mirror(P, R);
    draw(X, blue+opacity(0.3));

    // Just a test
    //Q = mirror(X, P);
    //dot(Q, orange);

    R = P;
    radius += 0.1;
}

draw((1,1)--(1,-1)--(-1,-1)--(-1,1)--cycle);
draw(unitcircle);
