import math;
import hyperbolic_geometry;

size(500,500);
settings.outformat="pdf";


// A simple demo with some normals

hyperbolic_point O = hyperbolic_point(0,0);

for (real ang=0; ang < 180; ang +=20) {
    hyperbolic_point A = hyperbolic_point(1.5, ang);
    hyperbolic_line l = hyperbolic_line(A,O);
    draw(l, blue);
    dot(A, blue);
    pair p = l.get_first_endpoint();
    dot(p, black);
}

for (real ang=10; ang < 180; ang +=20) {
    hyperbolic_point A = hyperbolic_point(1.5, ang);
    hyperbolic_line l = hyperbolic_line(O,A);
    draw(l, green);
    dot(A, green);
    pair p = l.get_first_endpoint();
    dot(p, black);
}

for (real ang=185; ang < 360; ang +=20) {
    hyperbolic_point A = hyperbolic_point(1.5, ang);
    hyperbolic_line l = hyperbolic_line(A,O);
    draw(l, yellow);
    dot(A, yellow);
    pair p = l.get_first_endpoint();
    dot(p, black);
}

for (real ang=195; ang < 360; ang +=20) {
    hyperbolic_point A = hyperbolic_point(1.5, ang);
    hyperbolic_line l = hyperbolic_line(O,A);
    draw(l, orange);
    dot(A, orange);
    pair p = l.get_first_endpoint();
    dot(p, black);
}

draw((1,1)--(1,-1)--(-1,-1)--(-1,1)--cycle);
draw(unitcircle);
