import math;
import hyperbolic_geometry;

size(500,500);
settings.outformat="pdf";

// What do we want to test?
// Some more or less random hyperbolic lines

hyperbolic_point A = hyperbolic_point(1,30);
hyperbolic_point B = hyperbolic_point(1,60);
dot(A);
dot(B);
hyperbolic_line g = hyperbolic_line(A,B);
draw(g);
dot(g.get_first_endpoint());
dot(g.get_second_endpoint());


hyperbolic_point C = hyperbolic_point(2.4,210);
hyperbolic_point D = hyperbolic_point(1.2,135);
dot(C);
dot(D);
hyperbolic_line h = hyperbolic_line(C,D);
draw(h, blue);
dot(h.get_first_endpoint());
dot(h.get_second_endpoint());


hyperbolic_point E = hyperbolic_point(0,5);
hyperbolic_point F = hyperbolic_point(2,5);
dot(E);
dot(F);
hyperbolic_line h = hyperbolic_line(E,F);
draw(h, green);
dot(h.get_first_endpoint());
dot(h.get_second_endpoint());


hyperbolic_point G = hyperbolic_point(2.8,80);
hyperbolic_point H = hyperbolic_point(2.8,100);
dot(G);
dot(H);
hyperbolic_line i = hyperbolic_line(G,H);
draw(i, red);
dot(i.get_first_endpoint());
dot(i.get_second_endpoint());


hyperbolic_point I = hyperbolic_point(1.2,80);
hyperbolic_point J = hyperbolic_point(1.2,100);
dot(I);
dot(J);
hyperbolic_line j = hyperbolic_line(I,J);
draw(j, orange);
dot(j.get_first_endpoint());
dot(j.get_second_endpoint());


hyperbolic_point K = hyperbolic_point(1.6,200);
hyperbolic_point L = hyperbolic_point(2,310);
dot(K);
dot(L);
hyperbolic_line k = hyperbolic_line(K,L);
draw(k, blue);
dot(k.get_first_endpoint());
dot(k.get_second_endpoint());

hyperbolic_point M = hyperbolic_point(1,110);
hyperbolic_point N = hyperbolic_point(1.3,0);
dot(M);
dot(N);
hyperbolic_line l = hyperbolic_line(M,N);
draw(l);
dot(l.get_first_endpoint());
dot(l.get_second_endpoint());

hyperbolic_point O = hyperbolic_point(1.8,45);
hyperbolic_point P = hyperbolic_point(1.9,225);
dot(O);
dot(P);
hyperbolic_line m = hyperbolic_line(O,P);
draw(m);
dot(m.get_first_endpoint());
dot(m.get_second_endpoint());

// Test for construction from endpoints only.
// This is for internal purposes! Do never use this.
pair x = unit((0.3, 0.2));
pair y = unit((0.4, -0.1));
hyperbolic_line L = hyperbolic_line();
L.configure(x,y);
draw(L, orange);
dot(x, gray);
dot(y, gray);

draw((1,1)--(1,-1)--(-1,-1)--(-1,1)--cycle);
draw(unitcircle);
