import math;
import hyperbolic_geometry;

size(500,500);
settings.outformat="pdf";

// What do we want to test?
// Test with many hyperbolic lines
// While we fix the first point and
// choose the second on a circle around
// the origin

hyperbolic_point O = hyperbolic_point(0,0);
dot(O,red);

hyperbolic_point P = hyperbolic_point(1, 0);
dot(P, blue);

int many = 41;

for (int j = 1; j < many+1; ++j) {
    hyperbolic_point Q = hyperbolic_point(1, j*360/(many+1));
    dot(Q, blue);
    hyperbolic_line L = hyperbolic_line(P, Q);
    draw(L, blue);
}

draw((1,1)--(1,-1)--(-1,-1)--(-1,1)--cycle);
draw(unitcircle);
