import math;
import hyperbolic_geometry;

size(500,500);
settings.outformat="pdf";

// What do we want to test?
// The rotation of hyperbolic circles around points

hyperbolic_point O = hyperbolic_point(0,0);
dot(O, black);
hyperbolic_point P = hyperbolic_point(2.0, 285);
dot(P, blue);

hyperbolic_point A = hyperbolic_point(1.8,20);
hyperbolic_point B = hyperbolic_point(1.5,340);
hyperbolic_point C = hyperbolic_point(0.5,10);

hyperbolic_circle T = hyperbolic_circle(A,B);


hyperbolic_point F;
hyperbolic_point G;
hyperbolic_segment S;
hyperbolic_circle K;
int maxi = 36;
for(int i = 1; i < maxi; ++i) {
    G = rotate(O, B, 360/maxi*i);

    K = rotate(O, T, 360/maxi*i);
    F = K.get_centerpoint();
    S = hyperbolic_segment(F,G);

    draw(K, gray);
    dot(K, gray);
    draw(S, gray);
    dot(G);
}

fill(T, blue+opacity(0.4));
draw(T);
dot(T);
dot(A, blue);
dot(B, blue);

int maxi = 36;
for(int i = 1; i < maxi; ++i) {
    G = rotate(P, B, 360/maxi*i);

    K = rotate(P, T, 360/maxi*i);
    F = K.get_centerpoint();
    S = hyperbolic_segment(F,G);

    draw(K, blue+opacity(0.5));
    dot(K, blue);
    draw(S, orange+opacity(0.6));
    dot(G, orange);
}

draw((1,1)--(1,-1)--(-1,-1)--(-1,1)--cycle);
draw(unitcircle);
