import math;
import hyperbolic_geometry;

size(500,500);
settings.outformat="pdf";

// What do we want to test?
// The rotation of hyperbolic rays around points

hyperbolic_point O = hyperbolic_point(0,0);
dot(O, blue);

hyperbolic_point E = hyperbolic_point(0.5,10);
dot(E, orange);

hyperbolic_point A = hyperbolic_point(1.8,20);
hyperbolic_point B = hyperbolic_point(1.5,340);
hyperbolic_ray L = hyperbolic_ray(A,B);
hyperbolic_ray M = hyperbolic_ray(O,A);

draw(L, blue);
draw(M, red);
dot(A);
dot(B);

hyperbolic_ray K;
int maxi = 50;
for(int i = 1; i < maxi; ++i) {
    K = rotate(A, L, 360/maxi*i);
    draw(K, gray);
}

int maxi = 10;
for(int i = 1; i < maxi; ++i) {
    K = rotate(O, M, 360/maxi*i);
    draw(K, yellow);
}

int maxi = 20;
for(int i = 1; i < maxi; ++i) {
    K = rotate(A, M, 360/maxi*i);
    draw(K, green);
}

int maxi = 36;
for(int i = 1; i < maxi; ++i) {
    K = rotate(O, L, 360/maxi*i);
    draw(K, blue);
}

int maxi = 50;
for(int i = 1; i < maxi; ++i) {
    K = rotate(E, L, 360/maxi*i);
    draw(K, orange);
}

draw((1,1)--(1,-1)--(-1,-1)--(-1,1)--cycle);
draw(unitcircle);
