import math;
import hyperbolic_geometry;

size(500,500);
settings.outformat="pdf";

// What do we want to test?
// The rotation of hyperbolic triangles around points

hyperbolic_point O = hyperbolic_point(0,0);
dot(O, gray);
hyperbolic_point P = hyperbolic_point(2.0, 285);
dot(P, blue);

hyperbolic_point A = hyperbolic_point(1.8,20);
hyperbolic_point B = hyperbolic_point(1.5,340);
hyperbolic_point C = hyperbolic_point(0.5,10);

hyperbolic_triangle T = hyperbolic_triangle(A,B,C);
fill(T, green);
draw(T);
dot(T);

hyperbolic_triangle K;
int maxi = 36;
for(int i = 1; i < maxi; ++i) {
    K = rotate(O, T, 360/maxi*i);
    draw(K, gray);
    dot(K);
}

int maxi = 36;
for(int i = 1; i < maxi; ++i) {
    K = rotate(P, T, 360/maxi*i);
    draw(K, blue+opacity(0.5));
    dot(K);
}

draw((1,1)--(1,-1)--(-1,-1)--(-1,1)--cycle);
draw(unitcircle);
