import math;
import hyperbolic_geometry;

size(500,500);
settings.outformat="pdf";

// What do we want to test?
// Hyperbolic distances between radialsymmetric points

hyperbolic_point O = hyperbolic_point(0,0);
dot(O,red);

hyperbolic_point C = hyperbolic_point(1,60);
hyperbolic_point P = hyperbolic_point(1,30);
hyperbolic_segment S = hyperbolic_segment(C,P);
draw(S, blue);
dot(C, black);
dot(P, blue);

hyperbolic_circle circ = hyperbolic_circle(C,P);
fill(circ, blue+opacity(0.3));
draw(circ, blue);

hyperbolic_circle circ = hyperbolic_circle(P,C);
draw(circ, red);

hyperbolic_circle circ = hyperbolic_circle(P,C,O);
fill(circ, green+opacity(0.3));
draw(circ, black);
dot(circ, green);


draw((1,1)--(1,-1)--(-1,-1)--(-1,1)--cycle);
draw(unitcircle);
