import math;
import hyperbolic_geometry;

size(500,500);
settings.outformat="pdf";

// Here we show usual the construction of the regular hexagon.
// This is done in analogy to the classical euclidean geometry.
// And this construction also fails.

hyperbolic_point O = hyperbolic_point(1.8,25);
hyperbolic_point A = hyperbolic_point(1,60);
hyperbolic_line OA = hyperbolic_line(O,A);

hyperbolic_circle C = hyperbolic_circle(O,A);

hyperbolic_circle C1 = hyperbolic_circle(A,O);
hyperbolic_point[] I1 = intersection(C,C1);

hyperbolic_circle C2 = hyperbolic_circle(I1[1],O);
hyperbolic_point[] I2 = intersection(C,C2);

hyperbolic_circle C3 = hyperbolic_circle(I2[1],O);
hyperbolic_point[] I3 = intersection(C,C3);

hyperbolic_circle C4 = hyperbolic_circle(I3[1],O);
hyperbolic_point[] I4 = intersection(C,C4);

hyperbolic_circle C5 = hyperbolic_circle(I4[1],O);
hyperbolic_point[] I5 = intersection(C,C5);

hyperbolic_circle C6 = hyperbolic_circle(I5[1],O);
hyperbolic_point[] I6 = intersection(C,C6);

hyperbolic_circle C7 = hyperbolic_circle(I6[1],O);
hyperbolic_point[] I7 = intersection(C,C7);

// The segments bilding the hexagon
hyperbolic_segment[] S;
S[0] = hyperbolic_segment(A, I1[1]);
S[1] = hyperbolic_segment(I1[1], I2[1]);
S[2] = hyperbolic_segment(I2[1], I3[1]);
S[3] = hyperbolic_segment(I3[1], I4[1]);
S[4] = hyperbolic_segment(I4[1], I5[1]);
S[5] = hyperbolic_segment(I5[1], I6[1]);
S[6] = hyperbolic_segment(I6[1], I7[1]);

// And draw all the stuff
draw(C, black);
draw(C1, gray);
draw(C2, gray);
draw(C3, gray);
draw(C4, gray);
draw(C5, gray);
draw(C6, gray);
draw(C7, gray);
draw(OA, black);
draw(S, orange);

dot(O, black);
dot(A, blue);
dot(I1[1], blue);
dot(I2[1], blue);
dot(I3[1], blue);
dot(I4[1], blue);
dot(I5[1], blue);
dot(I6[1], blue);
dot(I7[1], blue);

draw((1,1)--(1,-1)--(-1,-1)--(-1,1)--cycle);
draw(unitcircle);
