import math;
import hyperbolic_geometry;

size(500,500);
settings.outformat="pdf";

// What do we want to test?
// We want to set points inside the open unit disk for
// given values of hyperbolic coordinates (radius, angle)
// and test the conversion to euclidean coordinates.

dot((0,0), red);

for (int i = 1; i <= 50; ++i) {
    for (int j = 0; j < 36; ++j) {
        dot(to_euclidean(i*0.1, j*10), blue);
    }
}

draw((1,1)--(1,-1)--(-1,-1)--(-1,1)--cycle);
draw(unitcircle);
