import math;
import hyperbolic_geometry;

size(500,500);
settings.outformat="pdf";

// Just recursive mirroring of polygons at their sides.

hyperbolic_point O = hyperbolic_point(0,0);

int numsides = 5;

hyperbolic_point[] P;
for(int i = 0; i < numsides; ++i) {
    P[i] = hyperbolic_point(0.5, i*360/numsides);
}
hyperbolic_polygon pol0;
pol0 = hyperbolic_polygon(P);
fill(pol0, blue+opacity(1.0));
draw(pol0);
dot(pol0);

int maxi = 20;
hyperbolic_segment[] sides;
int ind = 0;
for(int i = 0; i <= maxi; ++i) {
    sides = pol0.get_sides();
    pol0 = mirror(sides[ind*i%2+ind*(i-1)%2], pol0);
    fill(pol0, blue+opacity(1.0/(i+0.1)));
    draw(pol0);
    dot(pol0);
    ind = (ind +1)%numsides;
    //ind = (i%2*(ind+1) + (i+1)%2*(numsides-ind-1))%numsides;
}

draw((1,1)--(1,-1)--(-1,-1)--(-1,1)--cycle);
draw(unitcircle);
