import math;
import hyperbolic_geometry;

size(500,500);
settings.outformat="pdf";

// What do we want to test?
// Mirroring hyperbolic triangles at hyperbolic lines.

hyperbolic_point O = hyperbolic_point(0,0);

hyperbolic_point A = hyperbolic_point(2,0);
hyperbolic_point B = hyperbolic_point(2,120);
hyperbolic_point C = hyperbolic_point(2, 240);
hyperbolic_point a = hyperbolic_point(0.5,20);
hyperbolic_point b = hyperbolic_point(0.5,140);
hyperbolic_point c = hyperbolic_point(0.5, 260);
hyperbolic_line M = hyperbolic_line(a,A);
hyperbolic_line N = hyperbolic_line(b,B);
hyperbolic_line K = hyperbolic_line(c,C);
dot(A, red);
dot(B, red);
dot(C, red);
dot(a, red);
dot(b, red);
dot(c, red);
draw(M, red);
draw(N, red);
draw(K, red);

hyperbolic_point P = hyperbolic_point(1,30);
hyperbolic_point Q = hyperbolic_point(2,60);
hyperbolic_point S = hyperbolic_point(0.4,48);

hyperbolic_triangle T = hyperbolic_triangle(P,Q,S);

fill(T, blue+opacity(1.0));
draw(T, black);
dot(T, black);

T = mirror(M, T);
fill(T, blue+opacity(0.9));
draw(T, black);
dot(T, black);

T = mirror(N, T);
fill(T, blue+opacity(0.8));
draw(T, black);
dot(T, black);

T = mirror(K, T);
fill(T, blue+opacity(0.7));
draw(T, black);
dot(T, black);

T = mirror(M, T);
fill(T, blue+opacity(0.6));
draw(T, black);
dot(T, black);

T = mirror(N, T);
fill(T, blue+opacity(0.5));
draw(T, black);
dot(T, black);

T = mirror(K, T);
fill(T, blue+opacity(0.4));
draw(T, black);
dot(T, black);

T = mirror(M, T);
fill(T, blue+opacity(0.3));
draw(T, black);
dot(T, black);

T = mirror(N, T);
fill(T, blue+opacity(0.2));
draw(T, black);
dot(T, black);

T = mirror(K, T);
fill(T, blue+opacity(0.1));
draw(T, black);
dot(T, black);

draw((1,1)--(1,-1)--(-1,-1)--(-1,1)--cycle);
draw(unitcircle);
