import math;
import hyperbolic_geometry;

size(500,500);
settings.outformat="pdf";


// A simple demo with some normals

hyperbolic_point A = hyperbolic_point(1.6,200);
hyperbolic_point B = hyperbolic_point(2,310);
dot(A, blue);
dot(B, blue);
hyperbolic_line l = hyperbolic_line(A, B);
draw(l, blue);
hyperbolic_line N = hyperbolic_normal(l, A);
draw(N, red);
hyperbolic_line N = hyperbolic_normal(l, B);
draw(N, red);

hyperbolic_point A = hyperbolic_point(1.5, 45);
hyperbolic_point B = hyperbolic_point(1.5, 225);
dot(A, blue);
dot(B, blue);
hyperbolic_line l = hyperbolic_line(A, B);
draw(l, blue);
hyperbolic_line N = hyperbolic_normal(l, A);
draw(N, red);
hyperbolic_line N = hyperbolic_normal(l, B);
draw(N, red);

draw((1,1)--(1,-1)--(-1,-1)--(-1,1)--cycle);
draw(unitcircle);
