import math;
import hyperbolic_geometry;

size(500,500);
settings.outformat="pdf";

// What do we want to test?
// Set real hyperbolic points given by their
// distance from the origin and an angle.
// The maximal distance is used is 2

hyperbolic_point O = hyperbolic_point(0,0);
dot(O,red);

int shells = 25;

for (int j = 1; j <= shells; ++j) {
	for (int i = 0; i<3*j; ++i) {
		hyperbolic_point X = hyperbolic_point(2/shells*j,(120/j)*i);
		dot(X, j/shells*red + (1-j/shells)*yellow);
	}
}

draw((1,1)--(1,-1)--(-1,-1)--(-1,1)--cycle);
draw(unitcircle);
