import math;
import hyperbolic_geometry;

size(500,500);
settings.outformat="pdf";

// What do we want to test?
// The rotation of polygons around points

hyperbolic_point O = hyperbolic_point(0.5,60);
dot(O,red);

hyperbolic_point E = hyperbolic_point(1,0);

hyperbolic_polygon pol = hyperbolic_regular_ngon(O,E,7);
fill(pol, blue);
draw(pol);
dot(pol);

hyperbolic_polygon qol;
int maxi = 12;
for(int i = 1; i < maxi; ++i) {
    qol = rotate(E, pol, 360/maxi*i);
    fill(qol, 0.2*red+blue+opacity(1-i*(1/(1.3*maxi))));
    draw(qol);
    dot(qol);
}

// hyperbolic_point[] EP = qol.get_corners();
// hyperbolic_segment[] side = qol.get_sides();
//
// for (int i = 0; i <= 6; ++i) {
//     string s = string(side[i].length(), 4);
//     label(s,(side[i].get_first_point().get_euclidean()+side[i].get_second_point().get_euclidean())/2);
// }
//
// for (int i = 0; i <= 6; ++i) {
//     string s = string(angle(EP[(i)%7], EP[(i+1)%7], EP[(i+2)%7]), 4);
//     label(s,EP[(i+1)%7].get_euclidean());
// }

draw((1,1)--(1,-1)--(-1,-1)--(-1,1)--cycle);
draw(unitcircle);
