import math;
import hyperbolic_geometry;

size(500,500);
settings.outformat="pdf";

// What do we want to test?
// Some more or less random hyperbolic lines

hyperbolic_point A = hyperbolic_point(1,30);
hyperbolic_point B = hyperbolic_point(1,60);
hyperbolic_segment g = hyperbolic_segment(A,B);
draw(g);
dot(g.get_first_point());
dot(g.get_second_point());


hyperbolic_point C = hyperbolic_point(2.4,210);
hyperbolic_point D = hyperbolic_point(1.2,135);
hyperbolic_segment h = hyperbolic_segment(C,D);
draw(h, blue);
dot(h.get_first_point());
dot(h.get_second_point());


hyperbolic_point E = hyperbolic_point(0,5);
hyperbolic_point F = hyperbolic_point(2,5);
hyperbolic_segment h = hyperbolic_segment(E,F);
draw(h, green);
dot(h.get_first_point());
dot(h.get_second_point());


hyperbolic_point G = hyperbolic_point(2.8,80);
hyperbolic_point H = hyperbolic_point(2.8,100);
hyperbolic_segment i = hyperbolic_segment(G,H);
draw(i, red);
dot(i.get_first_point());
dot(i.get_second_point());


hyperbolic_point I = hyperbolic_point(1.2,80);
hyperbolic_point J = hyperbolic_point(1.2,100);
hyperbolic_segment j = hyperbolic_segment(I,J);
draw(j, orange);
dot(j.get_first_point());
dot(j.get_second_point());


hyperbolic_point K = hyperbolic_point(1.6,200);
hyperbolic_point L = hyperbolic_point(2,310);
hyperbolic_segment k = hyperbolic_segment(K,L);
draw(k, blue);
dot(k.get_first_point());
dot(k.get_second_point());

hyperbolic_point M = hyperbolic_point(1,110);
hyperbolic_point N = hyperbolic_point(1.3,0);
hyperbolic_segment l = hyperbolic_segment(M,N);
draw(l);
dot(l.get_first_point());
dot(l.get_second_point());

hyperbolic_point O = hyperbolic_point(1.8,45);
hyperbolic_point P = hyperbolic_point(1.9,225);
hyperbolic_segment m = hyperbolic_segment(O,P);
draw(m);
dot(m.get_first_point());
dot(m.get_second_point());

draw((1,1)--(1,-1)--(-1,-1)--(-1,1)--cycle);
draw(unitcircle);
